//AKG4e3 : 高质量泛光（bloom）从理论到实战
//https://zhuanlan.zhihu.com/p/525500877

//感谢 Tahnass 在实现过程中提供的帮助

vec3 downSampling(sampler2D text, vec2 uv, float lod){
    
    float scale = exp2(lod);
    float offset = 0.0;
    for (int i = 1; i < int(lod); ++i) {
        offset += pow(0.5, i);
    }
    vec2 newUV = (uv - vec2(offset, 0.0)) * scale; 

    if(outScreen(newUV, 0.0)) return BLACK;
    
    vec3 blur = vec3(0.0);
    // blur = gaussianBlur55(text, newUV, scale, lod);
    blur = Filter5_22(text, newUV, scale, lod);

    return blur;
}

// vec2 samplingOffset[6] = vec2[](
//     vec2(0.0, 0.0),
//     vec2(0.6, 0.0),
//     vec2(0.0, 0.6),
//     vec2(0.225, 0.6),
//     vec2(0.3875, 0.6),
//     vec2(0.51875, 0.6)
// );

vec2 samplingOffset[7] = vec2[](
    vec2(0.0, 0.0),
    vec2(0.35, 0.0),
    vec2(0.575, 0.0),
    vec2(0.7375, 0.0),
    vec2(0.86875, 0.0),
    vec2(0.0, 0.35),
    vec2(0.1078125, 0.35)
);

vec3 horizontalDownSampling(sampler2D text, vec2 uv, float lod){
    // 采样坐标
    float scale = exp2(lod);
    // float offset = 0.0;
    // for (int i = 1; i < int(lod); ++i) {
    //     offset += pow(0.5, i);
    // }
    vec2 newUV = (uv - samplingOffset[int(lod - 2)] + vec2(0.225) / texResolution) * scale; 

    // 边缘检测
    if(outScreen(newUV)) return BLACK;

    //高斯模糊
    // float gaussianWeights[5];
    // calculateGaussianWeights(gaussianWeights, 1.0);
    vec3 blur = horizontalGaussianBlur(text, newUV, scale, lod);

    // vec3 blur = Filter5_22(text, newUV, scale, lod);
    // vec3 blur = gaussianBlur55(text, newUV, scale, lod);

    return blur;
}

vec3 upSampling(sampler2D text, vec2 uv, float lod){
    vec3 blur = vec3(0.0);

    float scale = exp2(-lod);
    vec2 newUV = uv * scale + samplingOffset[int(lod - 2)];

    // blur = tentFilter33(text, newUV, 1.0, 0.0, 0.0);
    // blur = gaussianBlur55(text, newUV, 1.0, 0.0);
    // blur = texture(text, newUV).rgb;
    // blur = SEUS_Bicubic(text, newUV).rgb;
    blur = textureBicubic(text, newUV).rgb;

    // gammaToLinear(blur);

    return blur;
}

vec3 getBloom(){
    vec3 blur = BLACK;  
    blur += upSampling(colortex4, texcoord, 2.0) * 1.62;
	blur += upSampling(colortex4, texcoord, 3.0) * 1.56;
	blur += upSampling(colortex4, texcoord, 4.0) * 1.49;
	blur += upSampling(colortex4, texcoord, 5.0) * 1.41;
	blur += upSampling(colortex4, texcoord, 6.0) * 1.32;
	blur += upSampling(colortex4, texcoord, 7.0) * 1.18;
	blur += upSampling(colortex4, texcoord, 8.0) * 1.0;

    // blur += upSampling(colortex4, texcoord, 2.0) * 1.0;
	// blur += upSampling(colortex4, texcoord, 3.0) * 1.18;
	// blur += upSampling(colortex4, texcoord, 4.0) * 1.32;
	// blur += upSampling(colortex4, texcoord, 5.0) * 1.41;
	// blur += upSampling(colortex4, texcoord, 6.0) * 1.49;
	// blur += upSampling(colortex4, texcoord, 7.0) * 1.56;
	// blur += upSampling(colortex4, texcoord, 8.0) * 1.62;

    // blur += upSampling(colortex4, texcoord, 2.0) * 1.0;
	// blur += upSampling(colortex4, texcoord, 3.0) * 1.0;
	// blur += upSampling(colortex4, texcoord, 4.0) * 1.0;
	// blur += upSampling(colortex4, texcoord, 5.0) * 1.0;
	// blur += upSampling(colortex4, texcoord, 6.0) * 1.0;
	// blur += upSampling(colortex4, texcoord, 7.0) * 1.0;
	// blur += upSampling(colortex4, texcoord, 8.0) * 1.0;

    // gammaToLinear(blur);

    return blur;
}





vec3 verticalDownSampling(sampler2D text, vec2 uv, float lod){
    // 采样坐标
    float scale = 1.0;
    float offset = 0.0;
    // for (int i = 1; i < int(lod); ++i) {
    //     offset += pow(0.5, i);
    // }
    vec2 newUV = (uv - vec2(offset, 0.0)) * scale; 

    // 边缘检测
    if(outScreen(newUV, 0.0)) return BLACK;

    //高斯模糊
    // float gaussianWeights[5];
    // calculateGaussianWeights(gaussianWeights, 1.0);
    vec3 blur = verticalGaussianBlur(text, newUV, scale, lod);

    return blur;
}