//gamma映射
void linearToGamma(inout vec3 color) {
	color = pow(color, vec3(1.0 / GAMMA));
}

void gammaToLinear(inout vec3 color) {
	color = pow(color, vec3(GAMMA));
}

void gammaToLinear(inout vec2 color) {
	color = pow(color, vec2(GAMMA));
}

vec3 gammaToLinearR(vec3 c) {
	return pow(c, vec3(GAMMA));
}

void linearToGamma(inout vec4 color) {
	color.rgb = pow(color.rgb, vec3(1.0 / GAMMA));
}

void gammaToLinear(inout vec4 color) {
	color.rgb = pow(color.rgb, vec3(GAMMA));
}

//计算颜色亮度
float getLuminance(vec3 color) {
	return dot(color, vec3(0.2126, 0.7152, 0.0722));
}

float getLuminance(vec4 color) {
	return dot(color.rgb, vec3(0.2126, 0.7152, 0.0722));
}

float getLuminance(sampler2D text, vec2 coord) {
	return dot(texture(text, coord).rgb, vec3(0.2126, 0.7152, 0.0722));
}

float getLuminance(sampler2D text, vec2 coord, float lod) {
	return dot(textureLod(text, coord, lod).rgb, vec3(0.2126, 0.7152, 0.0722));
}

//计算颜色亮度（点积WHITE）
float getLuminanceW(vec3 color) {
	return dot(WHITE, color);
}

float getLuminanceW(vec4 color) {
	return dot(WHITE, color.rgb);
}

float getLuminanceW(sampler2D text, vec2 coord) {
	return dot(WHITE, texture(text, coord).rgb);
}

vec3 RGB2YCoCgR(vec3 rgbColor){
    vec3 YCoCgRColor;

    YCoCgRColor.y = rgbColor.r - rgbColor.b;
    float temp = rgbColor.b + YCoCgRColor.y / 2;
    YCoCgRColor.z = rgbColor.g - temp;
    YCoCgRColor.x = temp + YCoCgRColor.z / 2;

    return YCoCgRColor;
}

vec3 YCoCgR2RGB(vec3 YCoCgRColor){
    vec3 rgbColor;

    float temp = YCoCgRColor.x - YCoCgRColor.z / 2;
    rgbColor.g = YCoCgRColor.z + temp;
    rgbColor.b = temp - YCoCgRColor.y / 2;
    rgbColor.r = rgbColor.b + YCoCgRColor.y;

    return rgbColor;
}
