// 基础数值
#define BLACK vec3(0.0, 0.0, 0.0)
#define WHITE vec3(1.0, 1.0, 1.0)

// 色彩
#define GAMMA 2.2

// 数值
#define PI 3.14159265359
#define _2PI 6.28318530718

// 坐标
#define CENTER_COORD vec2(0.5, 0.5)

// 方块标记
#define BLOCK_SCALE      50.0
#define PLANTS_SHORT     1.0
#define PLANTS_TALL_L    2.0
#define PLANTS_TALL_U    3.0
#define LEAVES           4.0
#define PLANTS_OTHER     5.0

#define WATER           11.0
#define ICE             12.0

#define GLOWING_BLOCK   21.0

#define GBF_TERRAIN     1.0
#define GBF_ENTITIES    2.0

// 时间
#define NOON_DURATION   20.0
#define NIGHT_DURATION  20.0

// 纹理
const int noiseTextureResolution = 64; 
// #define PARALLAX_MAPPING
#define TEXTURE_RESOLUTION 16 // [16 32 64 128 256 512 1024 2048 4096 8192]
#define PARALLAX_HEIGHT 0.3 // [0.0 0.05 0.1 0.15 0.2 0.25 0.3 0.35 0.4 0.45 0.5 0.6 0.7 0.8 0.9 1.0]
// #define VOXEL_PARALLAX
#define PARALLAX_SHADOW

#define ANISOTROPIC_FILTERING_QUALITY 8 // [2 4 8 16]



// TAA
#define TAA_JITTER_AMOUNT 1.0






// 植物晃动
#define WAVING_RATE 2.5
#define PLANTS_SHORT_AMPLITUDE 0.15
#define PLANTS_TALL_AMPLITUDE 0.04
#define LEAVES_AMPLITUDE 0.04
#define WAVING_DISTANCE 60.0





// 光照设置
vec3 IncomingLight = vec3(1.0, 1.0, 1.0) * 5.0;     // 入射阳光

#define NIGHT_LIGHT_BRI 0.013       // [0.005 0.007 0.010 0.013 0.016 0.019 0.022 0.025 0.030 0.035 0.040 0.045 0.050]
#define NIGHT_AMBIENT_BRI 0.010     // [0.005 0.007 0.010 0.013 0.016 0.019 0.022 0.025 0.030 0.035 0.040 0.045 0.050]

const float sunPathRotation = -40.0f;
// 阴影
const bool shadowHardwareFiltering = true;
const float shadowMap_BIAS = 0.90;
const int shadowMapResolution = 2048;
const float shadowDistanceRenderMul = 1.0f;
const float shadowDistance = 200.0f;
const float shadowIntervalSize = 2.0f;

// RSM
// #define RSM_M1
#define RSM_M2
// SSAO
const float ambientOcclusionLevel = 0.50f;






// 大气散射：预设
const float earth_r = 6371000.0;
const vec3 planetCenter = vec3(0.0, -earth_r, 0.0);
const float heightOffset = 1200.0;
const float camera_h = cameraPosition.y - 65.0 + heightOffset;
const float atmosphere_h = 30000.0;
const vec2 densityScale_h = vec2(8500.0f, 1200.0f) + vec2(heightOffset);   // 高度密度函数中的H O(7994,1200)
const vec3 RayleighSct = vec3(5.8f, 13.5f, 33.1f) * 0.000001f;
const vec3 MieSct = vec3(2.2f, 2.2f, 2.2f) * 0.00001f;
#define information CHUN_By_ZYPANDA
// 大气散射：设置
const float RayleighExtinctionCoef = 1.0;     // 透射
const float MieExtinctionCoef = 1.0;

const float RayleighScatterCoef = 1.0;        // 散射
const float MieScatterCoef = 0.35;

const float MieG = 0.76f;   // mie 相位函数的 G 值

// 体积云
const float cloudH = 850.0;
const float cloudT = 250.0;





// 水
#define WATER_REFRACT_IOR 1.33
vec3 waterFogColor = mix(vec3(0.20, 0.75, 0.95), vec3(0.60), rainStrength * 0.5);
#define FRESNEL_POWER 3.0





// 曝光
#define TARGET_BRIGHTNESS 0.175
#define LIGHT_SENSITIVITY 1.4
#define EXPOSURE_DELTA 0.4