varying vec2 texcoord;

#include "/lib/uniform.glsl"
#include "/lib/setting.glsl"
#include "/lib/common/common.glsl"
#include "/lib/camera/colorToolkit.glsl"


#ifdef FSH

#define CPS_FSH

#include "/lib/lighting/mcLightmap.glsl"


void main() {
	vec2 mcLightmap = unpack16Bit(texture(colortex1, texcoord).g);
	mcLightmap = AdjustLightmap(mcLightmap);

	vec3 ambient = vec3(mcLightmap.y);
	ambient = max(ambient, BLACK);

	float parallaxShadow = texture(colortex4, texcoord).a;

/* DRAWBUFFERS:4 */
	gl_FragData[0] = vec4(ambient, parallaxShadow);
}


#endif
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef VSH
#include "/lib/atmosphere/atmosphericScattering.glsl"

void main() {
	gl_Position = ftransform();
	texcoord = (gl_TextureMatrix[0] * gl_MultiTexCoord0).xy;
}
#endif
