varying vec2 texcoord;



#include "/lib/uniform.glsl"
#include "/lib/setting.glsl"
#include "/lib/common/common.glsl"
#include "/lib/camera/colorToolkit.glsl"
#include "/lib/common/position.glsl"
// #include "/lib/common/noise.glsl"

#ifdef FSH
// const bool colortex0MipmapEnabled = true;
const bool colortex4MipmapEnabled = true;

#define CPS_FSH
#include "/lib/camera/filter.glsl"
#include "/lib/TAA.glsl"
#include "/lib/camera/exposure.glsl"


void main() {
    vec3 nowColor = texture(colortex0, texcoord.st).rgb;
    
	TAA(nowColor);
    // vec2 velocity = texture(colortex3, getClosestOffset()).rg;
    // vec2 offsetUV = clamp01(texcoord.st - velocity);
    // // vec3 preColor = texture(colortex2, offsetUV).rgb;
    // vec3 preColor = catmullRom5(colortex2, offsetUV).rgb;
    // float blendFactor = 0.05;
    // blendFactor = getBlendFactor(velocity, preColor, nowColor);
    // nowColor = vec3(blendFactor);




    // 时间性曝光累计
    float temporalA = 0.0;
    if(floor(gl_FragCoord.xy) == ivec2(0, 0)){
        float AverageLum = texelFetch(colortex2, ivec2(0, 0), 0).a;
        AverageLum = mix(AverageLum, calculateAverageLuminance(), clamp01(frameTime*2.0));
        temporalA += AverageLum;
    }
    

/* DRAWBUFFERS:02 */
    gl_FragData[0] = vec4(nowColor, 1.0);
    gl_FragData[1] = vec4(nowColor, temporalA);	//输出当前颜色，作为下一帧的preColor
}


#endif
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef VSH

void main() {

	gl_Position = ftransform();
	texcoord = (gl_TextureMatrix[0] * gl_MultiTexCoord0).xy;
}
#endif
