varying vec2 texcoord;

varying vec3 sunWorldDir;

#include "/lib/uniform.glsl"
#include "/lib/setting.glsl"
#include "/lib/common/common.glsl"
#include "/lib/common/position.glsl"
#include "/lib/camera/colorToolkit.glsl"
// #include "/lib/common/noise.glsl"

#ifdef FSH
// const bool colortex0MipmapEnabled = true;
// const bool colortex4MipmapEnabled = true;

#define CPS_FSH
#include "/lib/camera/filter.glsl"
#include "/lib/TAA.glsl"
#include "/lib/camera/bloom.glsl"


void main() {
	//velocity
    float depth1 = texture(depthtex1, texcoord.st).r;
    vec4 viewPos = screenPosToViewPos(vec4(texcoord.st, depth1, 1.0));
	vec4 worldPos = viewPosToWorldPos(viewPos);
	vec2 prePos = getPrePos(worldPos);
	vec2 velocity = texcoord.st - prePos;

	// history color
	// vec3 preColor = tentFilter33(colortex2, texcoord, 1.0, 0.0, 0.0);
	// vec3 preColor = catmullRom5(colortex2, texcoord).rgb;
	// vec3 preColor = texture(colortex2, texcoord).rgb;





	//bloom
	vec3 color = texture(colortex0, texcoord).rgb;
	color = mix(color, getBloom(), 0.015 + 0.13 * clamp01(isEyeInWater) + rainStrength * 0.10);
	if(isEyeInWater == 1)	color = pow(color, vec3(1.50)) * 1.0;
	color = pow(color, vec3(1.0 + 0.2 * rainStrength)) * 1.0;
	// color = texture(colortex4, texcoord).rgb;





	// 曝光采样调整
	vec4 CT4 = vec4(BLACK, 1.0);
	CT4.rgb += color;
	vec3 worldDir = normalize(worldPos.xyz);
	// float depth0 = texture(depthtex0, texcoord.st).r;
	// if(depth0 == 1.0) 	CT4.rgb *= dot(worldDir, sunWorldDir) > 0.99965 ? 2.0 : 1.0;
	// vec3 sunScreenDir = viewPosToScreenPos(vec4(sunPosition, 0.0)).xyz;
	// vec3 upViewDir = normalize((gbufferModelView * vec4(upWorldDir, 0.0)).xyz);
	// if(!outScreen(sunScreenDir) && texture(depthtex1, sunScreenDir.st).r == 1.0)		
	// 	CT4 *= 2.0 * (1.0 + pow(clamp01(dot(sunPosition, upViewDir)), 0.1));

	color = max(BLACK, color);

/* DRAWBUFFERS:034 */
	gl_FragData[0] = vec4(color, 1.0);
	// gl_FragData[1] = vec4(preColor, 1.0);
	gl_FragData[1].rg = velocity;
	gl_FragData[2] = CT4;
}


#endif
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef VSH

void main() {
	sunWorldDir = normalize(viewPosToWorldPos(vec4(sunPosition, 0.0)).xyz);

	gl_Position = ftransform();
	texcoord = (gl_TextureMatrix[0] * gl_MultiTexCoord0).xy;
}
#endif
