varying vec2 texcoord;

varying vec3 sunWorldDir;
varying float isNoon;

#include "/lib/uniform.glsl"
#include "/lib/setting.glsl"
#include "/lib/common/common.glsl"
#include "/lib/camera/colorToolkit.glsl"
#include "/lib/camera/toneMapping.glsl"

#include "/lib/common/noise.glsl"
#include "/lib/common/position.glsl"

#ifdef FSH

const bool colortex0MipmapEnabled = true;

#define FINAL
#include "/lib/camera/exposure.glsl"

void main() {
	vec4 color = texture(colortex0, texcoord);
    


	avgExposure1(color.rgb);

	acesTonemap(color.rgb);
	
	linearToGamma(color.rgb);

	color.rgb += vec3(rand2_1(texcoord + sin(frameTimeCounter)) / 512.0);
	// color.rgb = vec3(texture(colortex2, texcoord).a);

/* DRAWBUFFERS:0 */
	gl_FragData[0] = color;
}


#endif
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef VSH

void main() {
	sunWorldDir = normalize(viewPosToWorldPos(vec4(sunPosition, 0.0)).xyz);
    isNoon = clamp01(dot(sunWorldDir, upWorldDir) * NOON_DURATION);
	gl_Position = ftransform();
	texcoord = (gl_TextureMatrix[0] * gl_MultiTexCoord0).xy;
}
#endif
