//varying
varying vec2 lmcoord;
varying vec2 texcoord;
varying vec4 glcolor;
varying vec2 normal;

#include "/lib/uniform.glsl"
#include "/lib/setting.glsl"
#include "/lib/common/common.glsl"
#include "/lib/common/normal.glsl"

#ifdef FSH

void main() {
	vec4 color = texture(tex, texcoord) * glcolor;
	// color *= texture(lightmap, lmcoord);

/* DRAWBUFFERS:014 */
	gl_FragData[0] = color;
	gl_FragData[1] = vec4(0.0, pack2x8Bits(vec2(lmcoord.x, lmcoord.y)), normal);
	gl_FragData[2] = vec4(vec3(0.0), 1.0);
	// gl_FragData[3] = vec4(0.0, 0.0, pack2x8Bits(vec2(lmcoord.y, 0.0)), 1.0);
	// gl_FragData[2].rg = normal;
}

#endif
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef VSH
#include "/lib/TAA.glsl"

void main() {
	gl_Position = ftransform();
	vec2 jitter = Halton_2_3[frameCounter % 8];	//-1 to 1
	jitter /= vec2(viewWidth, viewHeight);

	gl_Position.xyz /= gl_Position.w;
    gl_Position.xy += jitter * TAA_JITTER_AMOUNT;
    gl_Position.xyz *= gl_Position.w;
	
	texcoord = (gl_TextureMatrix[0] * gl_MultiTexCoord0).xy;
	lmcoord  = (gl_TextureMatrix[1] * gl_MultiTexCoord1).xy;
	glcolor = gl_Color;
	normal = normalEncode(gl_NormalMatrix * gl_Normal);
}
#endif