//varying
varying vec4 starData; //rgb = star color, a = flag for weather or not this pixel is a star.

#include "/lib/uniform.glsl"
#include "/lib/setting.glsl"
#include "/lib/common/common.glsl"

#ifdef FSH

float fogify(float x, float w) {
	return w / (x * x + w);
}

vec3 calcSkyColor(vec3 pos) {
	float upDot = dot(pos, gbufferModelView[1].xyz);
	return mix(skyColor, fogColor, fogify(max(upDot, 0.0), 0.25));
}

void main() {
	vec3 color = BLACK;
	// if (starData.a > 0.5) {
	// 	color = starData.rgb;
	// }
	// else {
	// 	vec4 pos = vec4(gl_FragCoord.xy / vec2(viewWidth, viewHeight) * 2.0 - 1.0, 1.0, 1.0);
	// 	pos = gbufferProjectionInverse * pos;
	// 	color = calcSkyColor(normalize(pos.xyz));
	// }

/* DRAWBUFFERS:0 */
	gl_FragData[0] = vec4(color, 1.0);
	// gl_FragData[1].rgb = vec3(0.0);
}

#endif
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef VSH
#include "/lib/TAA.glsl"

void main() {
	gl_Position = ftransform();
	// vec2 jitter = Halton_2_3[frameCounter % 8];	//-1 to 1
	// jitter /= vec2(viewWidth, viewHeight);

	// gl_Position.xyz /= gl_Position.w;
    // gl_Position.xy += jitter * TAA_JITTER_AMOUNT;
    // gl_Position.xyz *= gl_Position.w;
	
	// starData = vec4(gl_Color.rgb, float(gl_Color.r == gl_Color.g && gl_Color.g == gl_Color.b && gl_Color.r > 0.0));
}
#endif