//varying
varying vec2 lmcoord;
varying vec2 texcoord;
varying vec4 glcolor;

#include "/lib/uniform.glsl"
#include "/lib/setting.glsl"
#include "/lib/common/common.glsl"
#include "/lib/camera/colorToolkit.glsl"

#ifdef FSH

void main() {
	vec4 text = texture(tex, texcoord);
	// vec4 color = vec4(vec3(getLuminance(text.rgb) * 2.0), text.a) * glcolor;
	vec4 color = text * glcolor;
	// color *= texture(lightmap, lmcoord);

/* DRAWBUFFERS:01 */
	gl_FragData[0] = color;
	gl_FragData[1].g = pack2x8Bits(lmcoord);
}

#endif
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef VSH
#include "/lib/TAA.glsl"

void main() {
	gl_Position = ftransform();
	vec2 jitter = Halton_2_3[frameCounter % 8];	//-1 to 1
	jitter /= vec2(viewWidth, viewHeight);

	gl_Position.xyz /= gl_Position.w;
    gl_Position.xy += jitter * TAA_JITTER_AMOUNT;
    gl_Position.xyz *= gl_Position.w;
	
	texcoord = (gl_TextureMatrix[0] * gl_MultiTexCoord0).xy;
	lmcoord  = (gl_TextureMatrix[1] * gl_MultiTexCoord1).xy;
	glcolor = gl_Color;
}
#endif